% This set of code is part of the forecasting system of DO, Chl-a, and other
% water quality state variables using observation data, which is developed 
% by Xin Yu at the Virginia Institute of Marine Science. The code provided 
% here is for evaluation purposes. Using the code for applications other than
% evaluation requires permission from the Virginia Institute of Marine Science. 
% Please contact author Xin Yu (xinyu@vims.edu), 
% or Dr. Shen (Shen@shen.vime.edu) for additional information.  
% 2020.8.5

clear all; close all; clc;
restoredefaultpath 
addpath functions

%% some parameters setting for different runs
run_id='test01';
modn=1;

%% get forcings, forcing(ifor).var, forcing(ifor).time
load(['mat/' run_id '/forcing.mat']);

%% get data matrix A(ist,itime),x(ist),y(ist),z(ist),time(itime)
load(['mat/' run_id '/A.mat']);

%% call f_data_driven_model, it will do the eof, training, and print out, using the 75% for EOF and training
f_data_driven_model(A,x,y,z,time,forcing,'run_id',run_id,'mode_to_explain',modn);
