function f_plotSeasonal5(varargin) 
   dtime=varargin{1};   
   var=varargin{2};
   panel_name='';
   ylab='';
   color='k';
   use_mean_se=0;
   for iopt = 3 : 2 : nargin
	optvalue = varargin{iopt+1};
	switch lower(varargin{iopt})
        case 'xn'
            xn=optvalue;
        case 'yn'
            yn=optvalue;
        case 'clims'
            clims=optvalue;
        case 'use_mean_se'
            use_mean_se=optvalue;
        otherwise
            error(['argument ' varargin{iopt} 'not needed']);
    end
   end

   tmp=datevec(min(dtime));
   begin_year=tmp(1);
   tmp=datevec(max(dtime));
   end_year=tmp(1);
   %% get data
    mons=1:12;
    pdvar(length(mons))=0;
    ii=0;
    for imon=mons
        ii=ii+1;
        vn=0;
        clear tvar
        for iyear=begin_year:end_year
            a=find(dtime>=datenum(iyear,imon,1)&dtime<datenum(iyear,imon+1,1));
            if ~isempty(a)
                vn=vn+1; % valid record
                tvar(vn)=nanmean(var(a));
                bvar(vn,imon)=nanmean(var(a));
            end
        end
        if vn>=5
            %disp(['PlotMainStem_Seasonal: ' num2str(vn) 'valid records for day' num2str(iday)])
            pdvar(ii)=mean(tvar);
            stdvar(ii)=std(tvar);
            maxvar(ii)=max(tvar);
            minvar(ii)=min(tvar);
        else
            pdvar(ii)=NaN;
        end
    end
    bvar(bvar==0)=NaN;
    %% -- boxplot 
    hold on;
    for imon=1:12
        med=median(bvar(:,imon));
        se=std(bvar(:,imon))/sqrt(length(bvar(:,imon)));
        p25=prctile(bvar(:,imon),25);
        p75=prctile(bvar(:,imon),75);
        if use_mean_se==1
            med=nanmean(bvar(:,imon));
            p25=med-se;
            p75=med+se;
            meds(imon)=med;
        end
        plot([imon,imon],[p25,p75],'k-','linewidth',1,'color',[1 1 1]*0.5);
        plot([-0.2,0.2]+imon,[p25,p25],'k-','linewidth',1,'color',[1 1 1]*0.5);
        plot([-0.2,0.2]+imon,[p75,p75],'k-','linewidth',1,'color',[1 1 1]*0.5);
        plot(imon,med,'ko','markerfacecolor','k');
        p25s(imon)=p25;
        p75s(imon)=p75;
    end
    if use_mean_se==1
        plot(1:12,meds,'k--','linewidth',0.5);
    end
    xlim([0.5 12.5]);
    yrange=max(p75s)-min(p25s);
    ylim([min(p25s),max(p75s)]+[-0.2,0.2]*yrange);
%     legend('std','mean');
    ylabel(ylab);
%     xlabel('month')
    mons={'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug',...
        'Sep','Oct','Nov','Dec'};
    mons={'J','F','M','A','M','J','J','A',...
        'S','O','N','D'};
    lfreq=1;
    xtick=1:lfreq:12;
    for ii=1:length(xtick)
        xticklabels{ii}=mons{xtick(ii)};
    end
    set(gca,'FontSize',10,'XTick',xtick,'XTickLabels',xticklabels,'tickdir','out');
    grid on;
    set(gca,'GridLineStyle',':')
    %text(1,0.95*(y2-y1)+y1,{panel_name},'FontSize',10);
    box on;