function out=f_remove_seasonal(varargin)
time=reshape(varargin{1},[],1);
var=reshape(varargin{2},[],1);
anomaly=var*NaN;

% if the time interval is monthly 
if time(2)-time(1)>10 % likely monthly data, not need to interpolated into daily
    ttime=datevec(time);
    for imon=1:12
        a=find(ttime(:,2)==imon);
        seasonal(imon)=nanmean(var(a));
        anomaly(a)=var(a)-seasonal(imon);
    end
else % if the frequency of data is daily or even hourly
    % get days
    ttime=datevec(time);
    time=reshape(time,[],1); % have to make it column vector, otherwise may lead to matrix
    days=time-datenum([ttime(:,1),ones(length(time),1),ones(length(time),1)]);
    interval=20;
    seasontime=interval/2:interval:365;
    for iday=1:length(seasontime)
        a=find(abs(days-seasontime(iday))<=interval/2);
        seasonal(iday)=nanmean(var(a));
    end
    % get a seasonal time series
    itime=0;
    clear tmptime tmpseasonal
    for iyear=ttime(1,1):ttime(end,1)
        for iday=1:length(seasontime)
            itime=itime+1;
            tmptime(itime)=datenum(iyear,1,1)+seasontime(iday);
            tmpseasonal(itime)=seasonal(iday);
        end
    end
    interp_seasonal=interp1(tmptime,tmpseasonal,time,'pchip');
    anomaly=reshape(var,[],1)-reshape(interp_seasonal,[],1);
end

out.time=time;
out.anomaly=anomaly;
out.seasonal=var-anomaly; % output the seasonal with same length as with time, not just 12