function nntrain=f_train_each_mode(varargin)
disp(' ');
disp('========== train each mode ==========');
forcing=varargin{1};
target=varargin{2};

% additional options and their default values
out_mat='';
use_anomaly=0; % by default, not use the anomaly
show_fig=1;
save_fig=1;
fig_type='png';
pname='';
with_seasonal=1; % normally with season
run_id='test';
ntry=100; %number of nearual network tries, all will be saved. 
som=2; %1 for single; 2 for multiple. 
% additional options 
for iopt = 3 : 2 : nargin
	optvalue = varargin{iopt+1};
	switch lower(varargin{iopt})
        case 'out_mat'
            out_mat=optvalue;
        case 'use_anomaly'
            use_anomaly=optvalue;
        case 'show_fig'
            show_fig=optvalue;
        case 'save_fig'
            save_fig=optvalue;
        case 'fig_type'
            fig_type=optvalue;
        case 'pname'
            pname=optvalue;
        case 'run_id'
            run_id=optvalue;
        case 'som'
            som=optvalue;
        case 'with_seasonal'
            with_seasonal=optvalue;
        case 'ntry'
            ntry=optvalue;
        otherwise
            error(['argument not recoganized (due to spell error mostly): ' varargin{iopt}]);
    end
end
if exist(out_mat,'file')
    disp(['file already exist: ' out_mat]);
    disp('No need to train it again');
    return;
end
disp(['use anomaly ' num2str(use_anomaly)]);
disp(['with seasonal ' num2str(with_seasonal)]);
disp(['single or multiple regression ' num2str(som)]);
pause(2);

disp(['Simulation for ' pname ' start']); 
X=[];

if use_anomaly==1
    disp('-get target variable anomaly');
    out=f_remove_seasonal(target.time,target.var);
    if with_seasonal==1
        X(:,1)=out.seasonal;
    end
    
    target.anomaly=out.anomaly;
    for ifor=1:length(forcing)
        disp(['-get forcing variable anomaly for forcing #' num2str(ifor)]);
        out=f_remove_seasonal(forcing(ifor).time,forcing(ifor).var);
        forcing(ifor).anomaly=out.anomaly;
    end
end

fid=fopen(['mat/' run_id '/log.txt'],'a');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n','in f_train_each_mode.m ');
fprintf(fid,'%s\n',['use_anomaly ',num2str(use_anomaly)]);
fprintf(fid,'%s\n',['with_seasonal ',num2str(with_seasonal)]);
fprintf(fid,'%s\n',['som(single or multipe linear) ',num2str(som)]);

save target target
[X,asft]=f_asft(forcing,target,'run_id',run_id);
if with_seasonal==1
    Y=target.var;
else
    Y=target.anomaly;
end
%% 
Nlayers{1}=[ceil(length(forcing)),ceil(length(forcing)/2)];
itry=0;
for ilay=1:length(Nlayers)
    layers=Nlayers{ilay};
    for ii=1:ntry
        itry=itry+1;
        disp(['NN itry: #' num2str(itry)]);
        nn=f_neural(X,Y,layers);
        nntrain(itry).nn=nn;
        yp(itry,:)=nn.yp;
    end
end
save nntrain nntrain asft
if ~isempty(out_mat)
    movefile('nntrain.mat',out_mat,'f');
    disp(['save NN training results into ' out_mat]);
end
%% plot showing the results
if show_fig==1
    figure('position',[50 50 900 300]);
    axes('position',[0.0748373101952278 0.11 0.549365588355497 0.815]);
    plot(target.time,Y,'k-','linewidth',1);
    hold on;
    plot(target.time,mean(yp,1),'r-','linewidth',1);
    title('Training dataset');
    datetick('x','yyyy');
    xlabel('Time');
    ylabel('Target value');
    legend('Target y','Predicted y');
    set(gca,'tickdir','out','fontweight','bold','gridlinestyle','--'); 
    box on; grid on;
    
    axes('Position',[0.694690023452021 0.15322222046968 0.286871798673793 0.767888892628252]);
    scatter(Y,mean(yp,1),20,'k.');
    title('Training dataset');
    xlabel('Target y');
    ylabel('Predicted y');
    title('Training dataset');
    set(gca,'tickdir','out','fontweight','bold','gridlinestyle','--'); 
    box on; grid on;
    
    if save_fig==1&&~isempty(pname)
        saveas(gcf,['figs/',run_id '/' pname ' training and testing'],fig_type);
    end
end
fclose all;